/*
 Copyright (C) 2022 Ivan Polyakov

 This file is part of vilor's website.

 Vilor's website is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Vilor's website is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <string.h>
#include "utils.h"

char *strreplace(char *s, const char *s1, const char *s2) {
    char *p = strstr(s, s1);

    if (p) {
        size_t len1 = strlen(s1);
        size_t len2 = strlen(s2);
        if (len1 != len2) {
            memmove(p + len2, p + len1, strlen(p + len1) + 1);
        }
        memcpy(p, s2, len2);
    }

    return p;
}
